=== src/ast/rewriter/bit_blaster/CMakeLists.txt ===
z3_add_component(bit_blaster
  SOURCES
    bit_blaster.cpp
    bit_blaster_rewriter.cpp
  COMPONENT_DEPENDENCIES
    rewriter
    params
)
